## libsecp256k1 0.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.15)
  # MSVC runtime library flags are selected by the CMAKE_MSVC_RUNTIME_LIBRARY abstraction.
  cmake_policy(SET CMP0091 NEW)
  # MSVC warning flags are not in CMAKE_<LANG>_FLAGS by default.
  cmake_policy(SET CMP0092 NEW)
endif()

project(libsecp256k1
  # The package (a.k.a. release) version is based on semantic versioning 2.0.0 of
  # the API. All changes in experimental modules are treated as
  # backwards-compatible and therefore at most increase the minor version.
  VERSION 0.5.0
  DESCRIPTION "Optimized C library for ECDSA signatures and secret/public key operations on curve secp256k1."
  HOMEPAGE_URL "https://github.com/bitcoin-core/secp256k1"
  LANGUAGES C
)

if(CMAKE_VERSION VERSION_LESS 3.21)
  get_directory_property(parent_directory PARENT_DIRECTORY)
  if(parent_directory)
    set(PROJECT_IS_TOP_LEVEL OFF CACHE INTERNAL "Emulates CMake 3.21+ behavior.")
    set(${PROJECT_NAME}_IS_TOP_LEVEL OFF CACHE INTERNAL "Emulates CMake 3.21+ behavior.")
  else()
    set(PROJECT_IS_TOP_LEVEL ON CACHE INTERNAL "Emulates CMake 3.21+ behavior.")
    set(${PROJECT_NAME}_IS_TOP_LEVEL ON CACHE INTERNAL "Emulates CMake 3.21+ behavior.")
  endif()
  unset(parent_directory)
endif()

# The library version is based on libtool versioning of the ABI. The set of
# rules for updating the version can be found here:
# https://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
# All changes in experimental modules are treated as if they don't affect the
# interface and therefore only increase the revision.
set(${PROJECT_NAME}_LIB_VERSION_CURRENT 4)
set(${PROJECT_NAME}_LIB_VERSION_REVISION 0)
set(${PROJECT_NAME}_LIB_VERSION_AGE 2)

set(CMAKE_C_STANDARD 90)
set(CMAKE_C_EXTENSIONS OFF)

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

option(BUILD_SHARED_LIBS "Build shared libraries." ON)
option(SECP256K1_DISABLE_SHARED "Disable shared library. Overrides BUILD_SHARED_LIBS." OFF)
if(SECP256K1_DISABLE_SHARED)
  set(BUILD_SHARED_LIBS OFF)
endif()

option(SECP256K1_INSTALL "Enable installation." ${PROJECT_IS_TOP_LEVEL})

## Modules

# We declare all options before processing them, to make sure we can express
# dependendencies while processing.
option(SECP256K1_ENABLE_MODULE_ECDH "Enable ECDH module." ON)
option(SECP256K1_ENABLE_MODULE_RECOVERY "Enable ECDSA pubkey recovery module." OFF)
option(SECP256K1_ENABLE_MODULE_EXTRAKEYS "Enable extrakeys module." ON)
option(SECP256K1_ENABLE_MODULE_SCHNORRSIG "Enable schnorrsig module." ON)
option(SECP256K1_ENABLE_MODULE_ELLSWIFT "Enable ElligatorSwift module." ON)

# Processing must be done in a topological sorting of the dependency graph
# (dependent module first).
if(SECP256K1_ENABLE_MODULE_ELLSWIFT)
  add_compile_definitions(ENABLE_MODULE_ELLSWIFT=1)
endif()

if(SECP256K1_ENABLE_MODULE_SCHNORRSIG)
  if(DEFINED SECP256K1_ENABLE_MODULE_EXTRAKEYS AND NOT SECP256K1_ENABLE_MODULE_EXTRAKEYS)
    message(FATAL_ERROR "Module dependency error: You have disabled the extrakeys module explicitly, but it is required by the schnorrsig module.")
  endif()
  set(SECP256K1_ENABLE_MODULE_EXTRAKEYS ON)
  add_compile_definitions(ENABLE_MODULE_SCHNORRSIG=1)
endif()

if(SECP256K1_ENABLE_MODULE_EXTRAKEYS)
  add_compile_definitions(ENABLE_MODULE_EXTRAKEYS=1)
endif()

if(SECP256K1_ENABLE_MODULE_RECOVERY)
  add_compile_definitions(ENABLE_MODULE_RECOVERY=1)
endif()

if(SECP256K1_ENABLE_MODULE_ECDH)
  add_compile_definitions(ENABLE_MODULE_ECDH=1)
endif()

option(SECP256K1_USE_EXTERNAL_DEFAULT_CALLBACKS "Enable external default callback functions." OFF)
if(SECP256K1_USE_EXTERNAL_DEFAULT_CALLBACKS)
  add_compile_definitions(USE_EXTERNAL_DEFAULT_CALLBACKS=1)
endif()

set(SECP256K1_ECMULT_WINDOW_SIZE "AUTO" CACHE STRING "Window size for ecmult precomputation for verification, specified as integer in range [2..24]. \"AUTO\" is a reasonable setting for desktop machines (currently 15). [default=AUTO]")
set_property(CACHE SECP256K1_ECMULT_WINDOW_SIZE PROPERTY STRINGS "AUTO" 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24)
include(CheckStringOptionValue)
check_string_option_value(SECP256K1_ECMULT_WINDOW_SIZE)
if(SECP256K1_ECMULT_WINDOW_SIZE STREQUAL "AUTO")
  set(SECP256K1_ECMULT_WINDOW_SIZE 15)
endif()
add_compile_definitions(ECMULT_WINDOW_SIZE=${SECP256K1_ECMULT_WINDOW_SIZE})

set(SECP256K1_ECMULT_GEN_KB "AUTO" CACHE STRING "The size of the precomputed table for signing in multiples of 1024 bytes (on typical platforms). Larger values result in possibly better signing or key generation performance at the cost of a larger table. Valid choices are 2, 22, 86. \"AUTO\" is a reasonable setting for desktop machines (currently 22). [default=AUTO]")
set_property(CACHE SECP256K1_ECMULT_GEN_KB PROPERTY STRINGS "AUTO" 2 22 86)
check_string_option_value(SECP256K1_ECMULT_GEN_KB)
if(SECP256K1_ECMULT_GEN_KB STREQUAL "AUTO")
  set(SECP256K1_ECMULT_GEN_KB 22)
endif()
if(SECP256K1_ECMULT_GEN_KB EQUAL 2)
  add_compile_definitions(COMB_BLOCKS=2)
  add_compile_definitions(COMB_TEETH=5)
elseif(SECP256K1_ECMULT_GEN_KB EQUAL 22)
  add_compile_definitions(COMB_BLOCKS=11)
  add_compile_definitions(COMB_TEETH=6)
elseif(SECP256K1_ECMULT_GEN_KB EQUAL 86)
  add_compile_definitions(COMB_BLOCKS=43)
  add_compile_definitions(COMB_TEETH=6)
endif()

set(SECP256K1_TEST_OVERRIDE_WIDE_MULTIPLY "OFF" CACHE STRING "Test-only override of the (autodetected by the C code) \"widemul\" setting. Legal values are: \"OFF\", \"int128_struct\", \"int128\" or \"int64\". [default=OFF]")
set_property(CACHE SECP256K1_TEST_OVERRIDE_WIDE_MULTIPLY PROPERTY STRINGS "OFF" "int128_struct" "int128" "int64")
check_string_option_value(SECP256K1_TEST_OVERRIDE_WIDE_MULTIPLY)
if(SECP256K1_TEST_OVERRIDE_WIDE_MULTIPLY)
  string(TOUPPER "${SECP256K1_TEST_OVERRIDE_WIDE_MULTIPLY}" widemul_upper_value)
  add_compile_definitions(USE_FORCE_WIDEMUL_${widemul_upper_value}=1)
endif()
mark_as_advanced(FORCE SECP256K1_TEST_OVERRIDE_WIDE_MULTIPLY)

set(SECP256K1_ASM "AUTO" CACHE STRING "Assembly to use: \"AUTO\", \"OFF\", \"x86_64\" or \"arm32\" (experimental). [default=AUTO]")
set_property(CACHE SECP256K1_ASM PROPERTY STRINGS "AUTO" "OFF" "x86_64" "arm32")
check_string_option_value(SECP256K1_ASM)
if(SECP256K1_ASM STREQUAL "arm32")
  enable_language(ASM)
  include(CheckArm32Assembly)
  check_arm32_assembly()
  if(HAVE_ARM32_ASM)
    add_compile_definitions(USE_EXTERNAL_ASM=1)
  else()
    message(FATAL_ERROR "ARM32 assembly requested but not available.")
  endif()
elseif(SECP256K1_ASM)
  include(CheckX86_64Assembly)
  check_x86_64_assembly()
  if(HAVE_X86_64_ASM)
    set(SECP256K1_ASM "x86_64")
    add_compile_definitions(USE_ASM_X86_64=1)
  elseif(SECP256K1_ASM STREQUAL "AUTO")
    set(SECP256K1_ASM "OFF")
  else()
    message(FATAL_ERROR "x86_64 assembly requested but not available.")
  endif()
endif()

option(SECP256K1_EXPERIMENTAL "Allow experimental configuration options." OFF)
if(NOT SECP256K1_EXPERIMENTAL)
  if(SECP256K1_ASM STREQUAL "arm32")
    message(FATAL_ERROR "ARM32 assembly is experimental. Use -DSECP256K1_EXPERIMENTAL=ON to allow.")
  endif()
endif()

set(SECP256K1_VALGRIND "AUTO" CACHE STRING "Build with extra checks for running inside Valgrind. [default=AUTO]")
set_property(CACHE SECP256K1_VALGRIND PROPERTY STRINGS "AUTO" "OFF" "ON")
check_string_option_value(SECP256K1_VALGRIND)
if(SECP256K1_VALGRIND)
  find_package(Valgrind MODULE)
  if(Valgrind_FOUND)
    set(SECP256K1_VALGRIND ON)
    include_directories(${Valgrind_INCLUDE_DIR})
    add_compile_definitions(VALGRIND)
  elseif(SECP256K1_VALGRIND STREQUAL "AUTO")
    set(SECP256K1_VALGRIND OFF)
  else()
    message(FATAL_ERROR "Valgrind support requested but valgrind/memcheck.h header not available.")
  endif()
endif()

option(SECP256K1_BUILD_BENCHMARK "Build benchmarks." ON)
option(SECP256K1_BUILD_TESTS "Build tests." ON)
option(SECP256K1_BUILD_EXHAUSTIVE_TESTS "Build exhaustive tests." ON)
option(SECP256K1_BUILD_CTIME_TESTS "Build constant-time tests." ${SECP256K1_VALGRIND})
option(SECP256K1_BUILD_EXAMPLES "Build examples." OFF)

# Redefine configuration flags.
# We leave assertions on, because they are only used in the examples, and we want them always on there.
if(MSVC)
  string(REGEX REPLACE "/DNDEBUG[ \t\r\n]*" "" CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO}")
  string(REGEX REPLACE "/DNDEBUG[ \t\r\n]*" "" CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
  string(REGEX REPLACE "/DNDEBUG[ \t\r\n]*" "" CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL}")
else()
  string(REGEX REPLACE "-DNDEBUG[ \t\r\n]*" "" CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO}")
  string(REGEX REPLACE "-DNDEBUG[ \t\r\n]*" "" CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
  string(REGEX REPLACE "-DNDEBUG[ \t\r\n]*" "" CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL}")
  # Prefer -O2 optimization level. (-O3 is CMake's default for Release for many compilers.)
  string(REGEX REPLACE "-O3[ \t\r\n]*" "-O2" CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
endif()

# Define custom "Coverage" build type.
set(CMAKE_C_FLAGS_COVERAGE "${CMAKE_C_FLAGS_RELWITHDEBINFO} -O0 -DCOVERAGE=1 --coverage" CACHE STRING
  "Flags used by the C compiler during \"Coverage\" builds."
  FORCE
)
set(CMAKE_EXE_LINKER_FLAGS_COVERAGE "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO} --coverage" CACHE STRING
  "Flags used for linking binaries during \"Coverage\" builds."
  FORCE
)
set(CMAKE_SHARED_LINKER_FLAGS_COVERAGE "${CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO} --coverage" CACHE STRING
  "Flags used by the shared libraries linker during \"Coverage\" builds."
  FORCE
)
mark_as_advanced(
  CMAKE_C_FLAGS_COVERAGE
  CMAKE_EXE_LINKER_FLAGS_COVERAGE
  CMAKE_SHARED_LINKER_FLAGS_COVERAGE
)

get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
set(default_build_type "RelWithDebInfo")
if(is_multi_config)
  set(CMAKE_CONFIGURATION_TYPES "${default_build_type}" "Release" "Debug" "MinSizeRel" "Coverage" CACHE STRING
    "Supported configuration types."
    FORCE
  )
else()
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY
    STRINGS "${default_build_type}" "Release" "Debug" "MinSizeRel" "Coverage"
  )
  if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "Setting build type to \"${default_build_type}\" as none was specified")
    set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE STRING
      "Choose the type of build."
      FORCE
    )
  endif()
endif()

include(TryAppendCFlags)
if(MSVC)
  # Keep the following commands ordered lexicographically.
  try_append_c_flags(/W3) # Production quality warning level.
  try_append_c_flags(/wd4146) # Disable warning C4146 "unary minus operator applied to unsigned type, result still unsigned".
  try_append_c_flags(/wd4244) # Disable warning C4244 "'conversion' conversion from 'type1' to 'type2', possible loss of data".
  try_append_c_flags(/wd4267) # Disable warning C4267 "'var' : conversion from 'size_t' to 'type', possible loss of data".
  # Eliminate deprecation warnings for the older, less secure functions.
  add_compile_definitions(_CRT_SECURE_NO_WARNINGS)
else()
  # Keep the following commands ordered lexicographically.
  try_append_c_flags(-pedantic)
  try_append_c_flags(-Wall) # GCC >= 2.95 and probably many other compilers.
  try_append_c_flags(-Wcast-align) # GCC >= 2.95.
  try_append_c_flags(-Wcast-align=strict) # GCC >= 8.0.
  try_append_c_flags(-Wconditional-uninitialized) # Clang >= 3.0 only.
  try_append_c_flags(-Wextra) # GCC >= 3.4, this is the newer name of -W, which we don't use because older GCCs will warn about unused functions.
  try_append_c_flags(-Wnested-externs)
  try_append_c_flags(-Wno-long-long) # GCC >= 3.0, -Wlong-long is implied by -pedantic.
  try_append_c_flags(-Wno-overlength-strings) # GCC >= 4.2, -Woverlength-strings is implied by -pedantic.
  try_append_c_flags(-Wno-unused-function) # GCC >= 3.0, -Wunused-function is implied by -Wall.
  try_append_c_flags(-Wreserved-identifier) # Clang >= 13.0 only.

=== examples/CMakeLists.txt ===
function(add_example name)
  set(target_name ${name}_example)
  add_executable(${target_name} ${name}.c)
  target_include_directories(${target_name} PRIVATE
    ${PROJECT_SOURCE_DIR}/include
  )
  target_link_libraries(${target_name}
    secp256k1
    $<$<PLATFORM_ID:Windows>:bcrypt>
  )
  set(test_name ${name}_example)
  add_test(NAME ${test_name} COMMAND ${target_name})
  if(BUILD_SHARED_LIBS AND MSVC)
    # The DLL must reside either in the same folder where the executable is
    # or somewhere in PATH. Using the latter option.
    set_tests_properties(${test_name} PROPERTIES
      ENVIRONMENT "PATH=$<TARGET_FILE_DIR:secp256k1>;$ENV{PATH}"
    )
  endif()
endfunction()

add_example(ecdsa)

if(SECP256K1_ENABLE_MODULE_ECDH)
  add_example(ecdh)
endif()

if(SECP256K1_ENABLE_MODULE_SCHNORRSIG)
  add_example(schnorr)
endif()

=== src/CMakeLists.txt ===
# Must be included before CMAKE_INSTALL_INCLUDEDIR is used.
include(GNUInstallDirs)

add_library(secp256k1_precomputed OBJECT EXCLUDE_FROM_ALL
  precomputed_ecmult.c
  precomputed_ecmult_gen.c
)

# Add objects explicitly rather than linking to the object libs to keep them
# from being exported.
add_library(secp256k1 secp256k1.c $<TARGET_OBJECTS:secp256k1_precomputed>)

add_library(secp256k1_asm INTERFACE)
if(SECP256K1_ASM STREQUAL "arm32")
  add_library(secp256k1_asm_arm OBJECT EXCLUDE_FROM_ALL)
  target_sources(secp256k1_asm_arm PUBLIC
    asm/field_10x26_arm.s
  )
  target_sources(secp256k1 PRIVATE $<TARGET_OBJECTS:secp256k1_asm_arm>)
  target_link_libraries(secp256k1_asm INTERFACE secp256k1_asm_arm)
endif()

if(WIN32)
  # Define our export symbol only for shared libs.
  set_target_properties(secp256k1 PROPERTIES DEFINE_SYMBOL SECP256K1_DLL_EXPORT)
  target_compile_definitions(secp256k1 INTERFACE $<$<NOT:$<BOOL:${BUILD_SHARED_LIBS}>>:SECP256K1_STATIC>)
endif()

# Object libs don't know if they're being built for a shared or static lib.
# Grab the PIC property from secp256k1 which knows.
get_target_property(use_pic secp256k1 POSITION_INDEPENDENT_CODE)
set_target_properties(secp256k1_precomputed PROPERTIES POSITION_INDEPENDENT_CODE ${use_pic})

target_include_directories(secp256k1 INTERFACE
  # Add the include path for parent projects so that they don't have to manually add it.
  $<BUILD_INTERFACE:$<$<NOT:$<BOOL:${PROJECT_IS_TOP_LEVEL}>>:${PROJECT_SOURCE_DIR}/include>>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

# This emulates Libtool to make sure Libtool and CMake agree on the ABI version,
# see below "Calculate the version variables" in build-aux/ltmain.sh.
math(EXPR ${PROJECT_NAME}_soversion "${${PROJECT_NAME}_LIB_VERSION_CURRENT} - ${${PROJECT_NAME}_LIB_VERSION_AGE}")
set_target_properties(secp256k1 PROPERTIES
  SOVERSION ${${PROJECT_NAME}_soversion}
)
if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  set_target_properties(secp256k1 PROPERTIES
    VERSION ${${PROJECT_NAME}_soversion}.${${PROJECT_NAME}_LIB_VERSION_AGE}.${${PROJECT_NAME}_LIB_VERSION_REVISION}
  )
elseif(APPLE)
  if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.17)
    math(EXPR ${PROJECT_NAME}_compatibility_version "${${PROJECT_NAME}_LIB_VERSION_CURRENT} + 1")
    set_target_properties(secp256k1 PROPERTIES
      MACHO_COMPATIBILITY_VERSION ${${PROJECT_NAME}_compatibility_version}
      MACHO_CURRENT_VERSION ${${PROJECT_NAME}_compatibility_version}.${${PROJECT_NAME}_LIB_VERSION_REVISION}
    )
    unset(${PROJECT_NAME}_compatibility_version)
  elseif(BUILD_SHARED_LIBS)
    message(WARNING
      "The 'compatibility version' and 'current version' values of the DYLIB "
      "will diverge from the values set by the GNU Libtool. To ensure "
      "compatibility, it is recommended to upgrade CMake to at least version 3.17."
    )
  endif()
elseif(CMAKE_SYSTEM_NAME STREQUAL "Windows")
  set(${PROJECT_NAME}_windows "secp256k1")
  if(MSVC)
    set(${PROJECT_NAME}_windows "${PROJECT_NAME}")
  endif()
  set_target_properties(secp256k1 PROPERTIES
    ARCHIVE_OUTPUT_NAME "${${PROJECT_NAME}_windows}"
    RUNTIME_OUTPUT_NAME "${${PROJECT_NAME}_windows}-${${PROJECT_NAME}_soversion}"
  )
  unset(${PROJECT_NAME}_windows)
endif()
unset(${PROJECT_NAME}_soversion)

if(SECP256K1_BUILD_BENCHMARK)
  add_executable(bench bench.c)
  target_link_libraries(bench secp256k1)
  add_executable(bench_internal bench_internal.c)
  target_link_libraries(bench_internal secp256k1_precomputed secp256k1_asm)
  add_executable(bench_ecmult bench_ecmult.c)
  target_link_libraries(bench_ecmult secp256k1_precomputed secp256k1_asm)
endif()

if(SECP256K1_BUILD_TESTS)
  add_executable(noverify_tests tests.c)
  target_link_libraries(noverify_tests secp256k1_precomputed secp256k1_asm)
  add_test(NAME noverify_tests COMMAND noverify_tests)
  if(NOT CMAKE_BUILD_TYPE STREQUAL "Coverage")
    add_executable(tests tests.c)
    target_compile_definitions(tests PRIVATE VERIFY)
    target_link_libraries(tests secp256k1_precomputed secp256k1_asm)
    add_test(NAME tests COMMAND tests)
  endif()
endif()

if(SECP256K1_BUILD_EXHAUSTIVE_TESTS)
  # Note: do not include secp256k1_precomputed in exhaustive_tests (it uses runtime-generated tables).
  add_executable(exhaustive_tests tests_exhaustive.c)
  target_link_libraries(exhaustive_tests secp256k1_asm)
  target_compile_definitions(exhaustive_tests PRIVATE $<$<NOT:$<CONFIG:Coverage>>:VERIFY>)
  add_test(NAME exhaustive_tests COMMAND exhaustive_tests)
endif()

if(SECP256K1_BUILD_CTIME_TESTS)
  add_executable(ctime_tests ctime_tests.c)
  target_link_libraries(ctime_tests secp256k1)
endif()

if(SECP256K1_INSTALL)
  install(TARGETS secp256k1
    EXPORT ${PROJECT_NAME}-targets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )
  set(${PROJECT_NAME}_headers
    "${PROJECT_SOURCE_DIR}/include/secp256k1.h"
    "${PROJECT_SOURCE_DIR}/include/secp256k1_preallocated.h"
  )
  if(SECP256K1_ENABLE_MODULE_ECDH)
    list(APPEND ${PROJECT_NAME}_headers "${PROJECT_SOURCE_DIR}/include/secp256k1_ecdh.h")
  endif()
  if(SECP256K1_ENABLE_MODULE_RECOVERY)
    list(APPEND ${PROJECT_NAME}_headers "${PROJECT_SOURCE_DIR}/include/secp256k1_recovery.h")
  endif()
  if(SECP256K1_ENABLE_MODULE_EXTRAKEYS)
    list(APPEND ${PROJECT_NAME}_headers "${PROJECT_SOURCE_DIR}/include/secp256k1_extrakeys.h")
  endif()
  if(SECP256K1_ENABLE_MODULE_SCHNORRSIG)
    list(APPEND ${PROJECT_NAME}_headers "${PROJECT_SOURCE_DIR}/include/secp256k1_schnorrsig.h")
  endif()
  if(SECP256K1_ENABLE_MODULE_ELLSWIFT)
    list(APPEND ${PROJECT_NAME}_headers "${PROJECT_SOURCE_DIR}/include/secp256k1_ellswift.h")
  endif()
  install(FILES ${${PROJECT_NAME}_headers}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  )

  install(EXPORT ${PROJECT_NAME}-targets
    FILE ${PROJECT_NAME}-targets.cmake
    NAMESPACE ${PROJECT_NAME}::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
  )

  include(CMakePackageConfigHelpers)
  configure_package_config_file(
    ${PROJECT_SOURCE_DIR}/cmake/config.cmake.in
    ${PROJECT_NAME}-config.cmake
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
    NO_SET_AND_CHECK_MACRO
  )
  write_basic_package_version_file(${PROJECT_NAME}-config-version.cmake
    COMPATIBILITY SameMinorVersion
  )

  install(
    FILES
      ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake
      ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
  )

  include(GeneratePkgConfigFile)
  generate_pkg_config_file(${PROJECT_SOURCE_DIR}/libsecp256k1.pc.in)
  install(
    FILES
      ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
  )
endif()

## libsecp256k1 0.1~20160216

=== debian/changelog ===
libsecp256k1 (0.1~20160216-3) unstable; urgency=medium

  * Relax symbols check on experimental builds.
  * Declare compliance with Debian Policy 3.9.8.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 24 Apr 2016 19:16:59 +0200

libsecp256k1 (0.1~20160216-2) unstable; urgency=medium

  * Update copyright info:
    + Fix URLs to upstream source and issue tracker.
  * Build with --disable-jni, to avoid broken links to disabled
    experimental modules.
  * Stop build-depend on default-jdk-headless or libguava-java.
  * Drop JNI-related symbols.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 05 Apr 2016 03:30:51 +0200

libsecp256k1 (0.1~20160216-1) unstable; urgency=low

  * Initial release.
    Closes: bug#819887.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 03 Apr 2016 20:23:38 +0200

=== debian/control ===
Source: libsecp256k1
Section: libs
Priority: optional
Build-Depends: cdbs (>= 0.4.123~),
 devscripts,
 libtool,
 automake,
 autoconf,
 debhelper,
 dh-buildinfo,
 pkg-config,
 libgmp-dev,
 libssl-dev,
 autoconf-archive,
 dpkg-dev (>= 1.17.0),
 d-shlibs (>= 0.50),
 pkg-kde-tools
Maintainer: Debian Bitcoin Team <pkg-bitcoin-devel@lists.alioth.debian.org>
Uploaders: Jonas Smedegaard <dr@jones.dk>
Standards-Version: 3.9.8
Homepage: https://github.com/bitcoin/secp256k1
Vcs-Git: https://anonscm.debian.org/git/pkg-bitcoin/libsecp256k1.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-bitcoin/libsecp256k1.git

Package: libsecp256k1-0
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: library for EC operations on curve secp256k1
 An optimized C library for EC operations on curve secp256k1.
 .
 NB! This library is a work in progress and is being used to research
 best practices. Use at your own risk.
 .
 Features:
  * secp256k1 ECDSA signing/verification and key generation.
  * Adding/multiplying private/public keys.
  * Serialization/parsing of private keys, public keys, signatures.
  * Constant time, constant memory access signing and pubkey generation.
  * Derandomized DSA (via RFC6979 or with a caller provided function.)
  * Very efficient implementation.

Package: libsecp256k1-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsecp256k1-0 (= ${binary:Version}),
 ${devlibs:Depends},
 ${misc:Depends}
Description: library for EC operations on curve secp256k1 - development headers
 An optimized C library for EC operations on curve secp256k1.
 .
 NB! This library is a work in progress and is being used to research
 best practices. Use at your own risk.
 .
 Features:
  * secp256k1 ECDSA signing/verification and key generation.
  * Adding/multiplying private/public keys.
  * Serialization/parsing of private keys, public keys, signatures.
  * Constant time, constant memory access signing and pubkey generation.
  * Derandomized DSA (via RFC6979 or with a caller provided function.)
  * Very efficient implementation.
 .
 This package provides header files for developing your applications to
 use libbitcoin template engine.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2015-2016 Jonas Smedegaard <dr@jones.dk>
# Description: Main Debian packaging script for secp256k1
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# This needs to run (and thus be declared) before CDBS includes
debian/control:: debian/control.in
DEB_PHONY_RULES += debian/control.in
debian/control.in:: debian/control.in.in
	sed -e 's/__LIBPKG__/$(libpkg)/g' <$< >$@

DEB_AUTO_UPDATE_LIBTOOL = pre
DEB_AUTO_UPDATE_ACLOCAL = ,
DEB_AUTO_UPDATE_AUTOCONF = ,
DEB_AUTO_UPDATE_AUTOMAKE = ,
DEB_AUTO_UPDATE_AUTOHEADER = ,
include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/debhelper.mk

pkg = $(DEB_SOURCE_PACKAGE)
stem = $(patsubst lib%,%,$(pkg))
abi = 0
lib = lib$(stem)
libpkg = lib$(stem)-$(abi)
devpkg = lib$(stem)-dev

DEB_UPSTREAM_URL = https://github.com/bitcoin/secp256k1/archive

# Build-depend unversioned on debhelper
#  TODO: Drop when adopted in cdbs
CDBS_BUILD_DEPENDS_rules_debhelper_v9 = debhelper

CDBS_BUILD_DEPENDS +=, pkg-config, libgmp-dev, libssl-dev, autoconf-archive

# resolve if release is experimental
CDBS_BUILD_DEPENDS +=, dpkg-dev (>= 1.17.0)
EXP_RELEASE = $(filter experimental% UNRELEASED,$(shell dpkg-parsechangelog -S Distribution))

DEB_CONFIGURE_EXTRA_FLAGS += \
 --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
 --enable-endomorphism \
 --enable-module-recovery \
 $(if $(EXP_RELEASE),--enable-experimental)

# avoid accidentally linking against disabled experimental modules
#CDBS_BUILD_DEPENDS +=, default-jdk-headless | default-jdk, libguava-java
#DEB_CONFIGURE_EXTRA_FLAGS += --enable-jni
DEB_CONFIGURE_EXTRA_FLAGS += --disable-jni

DEB_MAKE_CHECK_TARGET = check

# relax symbols check when targeting experimental
export DPKG_GENSYMBOLS_CHECK_LEVEL=$(if $(EXP_RELEASE),0,1)

# Let d-shlibs calculate development package dependencies
#  and handle shared library install
#  * d-shlibs 0.50 required for --multiarch and --exclude-la options
CDBS_BUILD_DEPENDS +=, d-shlibs (>= 0.50)
binary-post-install/$(libpkg) binary-post-install/$(devpkg):: \
 debian/stamp-local-shlibs-$(lib)
debian/stamp-local-shlibs-$(lib): \
 binary-install/$(libpkg) \
 binary-install/$(devpkg)
	d-shlibmove --commit \
		--devunversioned \
		--exclude-la \
		--multiarch \
		--override 's/libgmp10-dev/libgmp-dev/' \
		--movedev "debian/tmp/usr/include/*" usr/include/ \
		--movedev "debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/*" \
			usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/$(lib).so
	touch $@
clean::
	rm -f debian/stamp-local-shlibs-$(lib)

# create autotools files from scratch during build
auxdir = build-aux
macrodir = $(auxdir)/m4
makefiledirs = .
autoheaders = src/$(lib)-config.h
files_autotools_core = $(auxdir)/config.guess $(auxdir)/config.sub
stems_m4_libtool = libtool ltoptions ltsugar ltversion lt~obsolete
files_libtool = $(auxdir)/ltmain.sh $(stems_m4_libtool:%=$(macrodir)/%.m4)
stems_m4_autoconf = pkg
stems_aux_autoconf = compile install-sh missing
files_autoconf = aclocal.m4 configure $(stems_aux_autoconf:%=$(auxdir)/%)
files_autoconf += $(stems_m4_autoconf:%=$(macrodir)/%.m4)
stems_m4_archive = jni_include_dir prog_cc_for_build
files_archive = $(stems_m4_archive:%=$(macrodir)/ax_%.m4)
files_automake = $(auxdir)/depcomp $(makefiledirs:=/Makefile.in)
files_automake += $(auxdir)/test-driver
files_autoheader = config.h.in $(autoheaders:=.in)
files_configure = config.log
stems_autotools = autotools_core libtool aclocal autoconf automake
stems_autotools += autoheader configure archive
files_autotools = $(foreach var,$(stems_autotools),$(files_$(var)))
DEB_UPSTREAM_CRUFT_MOVE = $(files_archive)
DEB_ACLOCAL_ARGS = -I$(macrodir) --install --force
DEB_AUTOMAKE_ARGS = --add-missing --copy --foreign --force
DEB_MAKE_CLEAN_TARGET = distclean
makefile-clean::
	rm -rf autom4te.cache
	rm -f $(filter-out $(DEB_UPSTREAM_CRUFT_MOVE),$(files_autotools))
clean::
	rm -f $(filter-out $(DEB_UPSTREAM_CRUFT_MOVE),$(files_autotools_core))
	test ! -d $(auxdir) || rmdir --ignore-fail-on-non-empty $(auxdir)

# track symbols using pkgkde-symbolshelper
CDBS_BUILD_DEPENDS +=, pkg-kde-tools
include /usr/share/pkg-kde-tools/makefiles/1/cdbs/symbolshelper.mk

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%secp256k1-$1.tar.gz%" \
 https://github.com/bitcoin/secp256k1/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian

## libsecp256k1 0.1~20161228

=== debian/changelog ===
libsecp256k1 (0.1~20161228-1) unstable; urgency=medium

  [ upstream ]
  * Snapshot from upstream git.
    + Remove Schnorr experiment.
    + Add exhaustive tests.
    + ecdsa_impl: replace scalar if-checks with VERIFY_CHECKs in
      ecdsa_sig_sign.
    + ecdh: test NULL-checking of arguments.
    + recovery: add tests to cover API misusage.
    + configure: add --enable-coverage to set options for coverage
      analysis.
    + group_impl.h: remove unused `secp256k1_ge_set_infinity` function.
    + Make the libcrypto detection fail the newer API.

  [ Jonas Smedegaard ]
  * Modernize git-buildpackage config: Filter any .git* file.
  * Drop obsolete lintian override regarding debhelper 9.
  * Unfuzz patch.
  * Update copyright info: Extend coverage of Debian packaging.
  * Build-depend on libssl-dev (not libssl1.0-dev).

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 10 Jan 2017 22:34:00 +0100

libsecp256k1 (0.1~20161026-1) unstable; urgency=medium

  [ upstream ]
  * Snapshot from upstream git.
    + Fix secp256k1_fe_inv_all_var parameter order.
    + Fix secp256k1_ge_set_all_gej_var parameter order.
    + Fix secp256k1_ge_set_table_gej_var parameter order.
    + Remove guarantees about memcmp-ability.
    + Fix auto-enabled static precompuatation.
    + Update scalar_4x64_impl.h.
    + Restructure nonce clearing.

  [ Jonas Smedegaard ]
  * Update watch file: Use substitution string @PACKAGE@.
  * Refresh patch.
  * Simplify README.source: Skip options set in gbp.conf.
  * Update copyright info:
    + Use license shortname FSFAP (not FSFUL~generic).
    + Add another copyright holder (no new license).
  * Build-depend on libssl1.0-dev (with older libssl-dev as fallback):
    OpenSSL 1.1 not yet supported upstream.
    Closes: Bug#828412. Thanks to Kurt Roeckx.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 17 Nov 2016 01:49:54 +0100

libsecp256k1 (0.1~20160804-1) unstable; urgency=medium

  [ upstream ]
  * Snapshot from upstream git.
    + align shared files copyright/comments to bitcoinj's.
    + Add some missing VERIFY_CHECK(ctx != NULL) for functions that use
      ARG_CHECK.
    + bench_ecdh: fix call to secp256k1_context_create.
    + Cast pointers through uintptr_t under JNI.
    + Update bitcoin-core GitHub links.
    + JNI: Only call ecdsa_verify if its inputs parsed correctly.
    + Add testcase which hits additional branch in secp256k1_scalar_sqr.
    + Fix state size in sha256 struct.
    + Fix undefs in hash_impl.h.
    + ARM assembly implementation of field_10x26 inner.
    + Test whether ECDH and Schnorr are enabled for JNI.
    + build: verify that the native compiler works for static precomp.
    + ecmult_const: unify endomorphism and non-endomorphism skew cases.
    + Add Jacobi symbol test via GMP.
    + Add function for testing quadratic residue field/group elements.
    + configure: add flag to disable OpenSSL tests.
    + Make secp256k1_fe_sqrt constant time.
    + Add string.h include to ecmult_impl.

  [ Jonas Smedegaard ]
  * Modernize CDBS: Build-depend on licensecheck (not devscripts).
  * Update copyright info: Adjust some files now licensed Apache-2.0.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 27 Aug 2016 13:53:04 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: libs
 Priority: optional
 Build-Depends: cdbs (>= 0.4.123~),
- devscripts,
+ licensecheck,
  libtool,
  automake,
  autoconf,
@@ -10,8 +10,8 @@
  dh-buildinfo,
  pkg-config,
  libgmp-dev,
+ autoconf-archive,
  libssl-dev,
- autoconf-archive,
  dpkg-dev (>= 1.17.0),
  d-shlibs (>= 0.50),
  pkg-kde-tools

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 # -*- mode: makefile; coding: utf-8 -*-
-# Copyright © 2015-2016 Jonas Smedegaard <dr@jones.dk>
+# Copyright © 2016-2017 Jonas Smedegaard <dr@jones.dk>
 # Description: Main Debian packaging script for secp256k1
 #
 # This program is free software; you can redistribute it and/or modify
@@ -41,11 +41,8 @@
 
 DEB_UPSTREAM_URL = https://github.com/bitcoin/secp256k1/archive
 
-# Build-depend unversioned on debhelper
-#  TODO: Drop when adopted in cdbs
-CDBS_BUILD_DEPENDS_rules_debhelper_v9 = debhelper
-
-CDBS_BUILD_DEPENDS +=, pkg-config, libgmp-dev, libssl-dev, autoconf-archive
+CDBS_BUILD_DEPENDS +=, pkg-config, libgmp-dev, autoconf-archive
+CDBS_BUILD_DEPENDS +=, libssl-dev
 
 # resolve if release is experimental
 CDBS_BUILD_DEPENDS +=, dpkg-dev (>= 1.17.0)

## libsecp256k1 0.1~20170810

=== debian/changelog ===
libsecp256k1 (0.1~20170810-2) unstable; urgency=medium

  * Update Vcs-* fields: Source moved to Salsa.
  * Declare compliance with Debian Policy 4.1.4.
  * Use tracker.debian team email as Maintainer.
    Closes: Bug#899587. Thanks to Christoph Biedl.
  * Update watch file: Add usage comment. Use substitution strings.
  * Update package relations:
    + Stop build-depend explicitly on recent dpkg-dev:
      Needed version satisfied even in oldstable.
    + Relax to build-depend unversioned on d-shlibs:
      Needed version satisfied even in oldstable.
  * Tighten lintian overrides regarding License-Reference.
  * Update copyright info: Extend coverage of Debian packaging.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 21 Jun 2018 11:36:23 +0200

libsecp256k1 (0.1~20170810-1) unstable; urgency=medium

  [ upstream ]
  * Snapshot from upstream git.
    + Add secp256k1_ec_pubkey_negate and secp256k1_ec_privkey_negate.
    + Fix typos in code comments and documentation.
    + Document secp256k1_context_randomize.
    + Use checked_alloc in test.
    + Remove executable bit from secp256k1.c
    + Minor optimizations to _scalar_inverse to save 4M.
    + Unroll secp256k1_fe_(get|set)_b32 for 5x52.
    + Unroll secp256k1_fe_(get|set)_b32 for 10x26.
    + Fix benchmark print_number infinite loop.
    + Further shorten the addition chain for scalar inversion.
    + Remove residual parts from the schnorr expirement.
    + add pubkey prefix constants to include/secp256k1.h.
    + Remove redundant conditional expression.
    + Fix wnaf_const documentation with respect to return value and
      number of words set.

  [ Jonas Smedegaard ]
  * Modernize Vcs-* fields: Use git (not cgit) in path.
  * Declare compliance with Debian Policy 4.0.1.
  * Advertise DEP3 format in patch headers.
  * Modernize cdbs:
    + Do copyright-check in maintainer script (not during build).
    + Relax to build-depend unversioned on cdbs.
    + Stop build-depend on licensecheck.
  * Update symbols file.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 18 Aug 2017 13:23:27 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: libsecp256k1
 Section: libs
 Priority: optional
-Build-Depends: cdbs (>= 0.4.123~),
- licensecheck,
+Build-Depends: cdbs,
  libtool,
  automake,
  autoconf,
@@ -12,15 +11,14 @@
  libgmp-dev,
  autoconf-archive,
  libssl-dev,
- dpkg-dev (>= 1.17.0),
- d-shlibs (>= 0.50),
+ d-shlibs,
  pkg-kde-tools
-Maintainer: Debian Bitcoin Team <pkg-bitcoin-devel@lists.alioth.debian.org>
+Maintainer: Debian Cryptocoin Team <team+cryptocoin@tracker.debian.org>
 Uploaders: Jonas Smedegaard <dr@jones.dk>
-Standards-Version: 3.9.8
+Standards-Version: 4.1.4
 Homepage: https://github.com/bitcoin/secp256k1
-Vcs-Git: https://anonscm.debian.org/git/pkg-bitcoin/libsecp256k1.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-bitcoin/libsecp256k1.git
+Vcs-Git: https://salsa.debian.org/cryptocoin-team/libsecp256k1.git
+Vcs-Browser: https://salsa.debian.org/cryptocoin-team/libsecp256k1
 
 Package: libsecp256k1-0
 Section: libs

=== debian/rules ===
--- 
+++ 
@@ -41,11 +41,14 @@
 
 DEB_UPSTREAM_URL = https://github.com/bitcoin/secp256k1/archive
 
+# suppress checking license during build
+DEB_COPYRIGHT_CHECK_LICENSECHECK =
+CDBS_BUILD_DEPENDS_rules_utils_copyright-check =
+
 CDBS_BUILD_DEPENDS +=, pkg-config, libgmp-dev, autoconf-archive
 CDBS_BUILD_DEPENDS +=, libssl-dev
 
 # resolve if release is experimental
-CDBS_BUILD_DEPENDS +=, dpkg-dev (>= 1.17.0)
 EXP_RELEASE = $(filter experimental% UNRELEASED,$(shell dpkg-parsechangelog -S Distribution))
 
 DEB_CONFIGURE_EXTRA_FLAGS += \
@@ -67,7 +70,7 @@
 # Let d-shlibs calculate development package dependencies
 #  and handle shared library install
 #  * d-shlibs 0.50 required for --multiarch and --exclude-la options
-CDBS_BUILD_DEPENDS +=, d-shlibs (>= 0.50)
+CDBS_BUILD_DEPENDS +=, d-shlibs
 binary-post-install/$(libpkg) binary-post-install/$(devpkg):: \
  debian/stamp-local-shlibs-$(lib)
 debian/stamp-local-shlibs-$(lib): \

=== debian/watch ===
# run "uscan --report" to check or "gbp import-orig --uscan" to update
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
 https://github.com/bitcoin/secp256k1/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## libsecp256k1 0.1~20170810-1+8.0trisquel1

=== debian/changelog ===
libsecp256k1 (0.1~20170810-1+8.0trisquel1) flidas; urgency=medium

  * Backported from bionic

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Mon, 08 Oct 2018 20:16:34 +0000

## libsecp256k1 0.1~20210108

=== debian/changelog ===
libsecp256k1 (0.1~20210108-1) unstable; urgency=medium

  [ upstream ]
  * development snapshot

  [ Jonas Smedegaard ]
  * update symbols file

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 08 Jan 2021 14:58:55 +0100

libsecp256k1 (0.1~20201209-3) experimental; urgency=medium

  * enable experimental modules extrakeys schnorrsig

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 04 Jan 2021 19:54:30 +0100

libsecp256k1 (0.1~20201209-2) experimental; urgency=medium

  * fix enable modules recovery ecdh,
    and stop enable experimental (even when targeting experimental)

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 04 Jan 2021 18:37:50 +0100

libsecp256k1 (0.1~20201209-1) experimental; urgency=medium

  [ upstream ]
  * development snapshot

  [ Jonas Smedegaard ]
  * declare compliance with Debian Policy 4.5.1
  * copyright: drop superfluous git protocol Source URL
  * use debhelper compatibility 10 (not 0)
  * update source script copyright-check
  * copyright: update coverage
  * unfuzz patch 1001
  * update build routines
  * enable module ecdh;
    closes: bug#940967, thanks to Janus Troelsen
  * simplify build;
    stop build-depend on cdbs libtool dh-autoreconf
  * use debhelper compatibility level 13 (not 10);
    build-depend on debhelper-compat (not debhelper)
  * update long description, based on upstream README

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 04 Jan 2021 01:42:12 +0100

libsecp256k1 (0.1~20190905-1) experimental; urgency=medium

  [ upstream ]
  * Snapshot from upstream git.

  [ Jonas Smedegaard ]
  * Fix have development package depend on pkg-config.
  * Update watch file: Fix syntax.
  * Declare compliance with Debian Policy 4.4.0.
  * Rename patch fix_automake.patch → 1001_fix_automake.patch,
    and document patch name micro-policy in debian/patches/README.
    Unfuzz patch 1001.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 23 Sep 2019 09:38:32 +0200

libsecp256k1 (0.1~20190331-1) experimental; urgency=medium

  [ upstream ]
  * Snapshot from upstream git.

  [ Jonas Smedegaard ]
  * Update copyright info:
    + Extend coverage for main upstream authors.
    + Extend coverage of packaging.
  * Simplify rules.
    Stop build-depend on dh-buildinfo.
  * Set Rules-Requires-Root: no.
  * Update watch file:
    + Use git mode.
    + Rewrite usage comment.
  * Update patch to fix automake.
  * Update symbols file: Add 3 symbols.
  * Use autoreconf (not custom rules).
    Build-depend on dh-autoreconf.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 10 Apr 2019 11:32:42 +0200

=== debian/control ===
Source: libsecp256k1
Section: libs
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 pkg-config,
 libgmp-dev,
 autoconf-archive,
 libssl-dev,
 d-shlibs,
 pkg-kde-tools
Maintainer: Debian Cryptocoin Team <team+cryptocoin@tracker.debian.org>
Uploaders: Jonas Smedegaard <dr@jones.dk>
Standards-Version: 4.5.1
Homepage: https://github.com/bitcoin/secp256k1
Vcs-Git: https://salsa.debian.org/cryptocoin-team/libsecp256k1.git
Vcs-Browser: https://salsa.debian.org/cryptocoin-team/libsecp256k1
Rules-Requires-Root: no

Package: libsecp256k1-0
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: library for EC operations on curve secp256k1
 An optimized C library for EC operations on curve secp256k1.
 .
 NB! This library is intended to be
 the highest quality publicly available library
 for cryptography on the secp256k1 curve.
 However, the primary focus of its development has been
 for usage in the Bitcoin system
 and usage unlike Bitcoin's may be less well tested, verified,
 or suffer from a less well thought out interface.
 Correct usage requires some care and consideration
 that the library is fit for your application's purpose.
 .
 Features:
  * secp256k1 ECDSA signing/verification and key generation.
  * Additive and multiplicative tweaking of secret/public keys.
  * Serialization/parsing of secret keys, public keys, signatures.
  * Constant time, constant memory access signing and public key generation.
  * Derandomized ECDSA (via RFC6979 or with a caller provided function.)
  * Very efficient implementation.
  * Suitable for embedded systems.
  * Optional module for public key recovery.
  * Optional module for ECDH key exchange.

Package: libsecp256k1-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsecp256k1-0 (= ${binary:Version}),
 pkg-config,
 ${devlibs:Depends},
 ${misc:Depends}
Description: library for EC operations on curve secp256k1 - development headers
 An optimized C library for EC operations on curve secp256k1.
 .
 NB! This library is intended to be
 the highest quality publicly available library
 for cryptography on the secp256k1 curve.
 However, the primary focus of its development has been
 for usage in the Bitcoin system
 and usage unlike Bitcoin's may be less well tested, verified,
 or suffer from a less well thought out interface.
 Correct usage requires some care and consideration
 that the library is fit for your application's purpose.
 .
 Features:
  * secp256k1 ECDSA signing/verification and key generation.
  * Additive and multiplicative tweaking of secret/public keys.
  * Serialization/parsing of secret keys, public keys, signatures.
  * Constant time, constant memory access signing and public key generation.
  * Derandomized ECDSA (via RFC6979 or with a caller provided function.)
  * Very efficient implementation.
  * Suitable for embedded systems.
  * Optional module for public key recovery.
  * Optional module for ECDH key exchange.
 .
 This package provides header files for developing your applications to
 use libbitcoin template engine.

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
mode=git,pgpmode=none,pretty=0.1~%cd \
https://github.com/bitcoin/secp256k1 HEAD

## libsecp256k1 0.1~20210825

=== debian/changelog ===
libsecp256k1 (0.1~20210825-2) unstable; urgency=medium

  * update symbols file

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 10 Sep 2021 23:27:27 +0200

libsecp256k1 (0.1~20210825-1) experimental; urgency=medium

  * declare compliance with Debian Policy 4.6.0
  * improve source helper script copyright-check
  * update copyright info: update coverage

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 10 Sep 2021 12:53:53 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  pkg-kde-tools
 Maintainer: Debian Cryptocoin Team <team+cryptocoin@tracker.debian.org>
 Uploaders: Jonas Smedegaard <dr@jones.dk>
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/bitcoin/secp256k1
 Vcs-Git: https://salsa.debian.org/cryptocoin-team/libsecp256k1.git
 Vcs-Browser: https://salsa.debian.org/cryptocoin-team/libsecp256k1

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_auto_configure:
	dh_auto_configure -- \
		--enable-module-recovery \
		--enable-module-ecdh \
		--enable-experimental \
		--enable-module-extrakeys \
		--enable-module-schnorrsig

# Let d-shlibs calculate development package dependencies
#  and handle shared library install
override_dh_install:
	dh_install
	d-shlibmove --commit \
		--devunversioned \
		--exclude-la \
		--multiarch \
		--movedev "debian/tmp/usr/include/*" usr/include/ \
		--movedev "debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/*" \
			usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.so

## libsecp256k1 0.1~20220711

=== debian/changelog ===
libsecp256k1 (0.1~20220711-1) unstable; urgency=medium

  * Team upload
  * New upstream version 0.1~20220711 (Closes: #1006505)
  * symbols: Add new secp256k1_schnorrsig_sign32

 -- Bastian Germann <bage@debian.org>  Thu, 14 Jul 2022 19:33:49 +0200

## libsecp256k1 0.2.0

=== debian/changelog ===
libsecp256k1 (0.2.0-2) unstable; urgency=medium

  * Team upload
  * Move to unstable

 -- Bastian Germann <bage@debian.org>  Tue, 27 Dec 2022 13:11:26 +0100

libsecp256k1 (0.2.0-1) experimental; urgency=medium

  * Team upload
  * Scan for releases
  * New upstream version 0.2.0
  * Name the library according to released SONAME

 -- Bastian Germann <bage@debian.org>  Tue, 20 Dec 2022 13:21:54 +0100

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
 Vcs-Browser: https://salsa.debian.org/cryptocoin-team/libsecp256k1
 Rules-Requires-Root: no
 
-Package: libsecp256k1-0
+Package: libsecp256k1-1
 Section: libs
 Architecture: any
 Depends:
@@ -53,7 +53,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libsecp256k1-0 (= ${binary:Version}),
+Depends: libsecp256k1-1 (= ${binary:Version}),
  pkg-config,
  ${devlibs:Depends},
  ${misc:Depends}

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
mode=git \
https://github.com/bitcoin/secp256k1 refs/tags/v([\d\.]+)

## libsecp256k1 0.5.0

=== debian/changelog ===
libsecp256k1 (0.5.0-2) unstable; urgency=medium

  * Team upload
  * Move to pkgconf

 -- Bastian Germann <bage@debian.org>  Mon, 13 May 2024 21:09:44 +0200

libsecp256k1 (0.5.0-1) experimental; urgency=medium

  * Team upload
  * New upstream version 0.5.0 (Closes: #1065745)

 -- Bastian Germann <bage@debian.org>  Sun, 12 May 2024 15:23:18 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Build-Depends:
  debhelper-compat (= 13),
- pkg-config,
+ pkgconf,
  libgmp-dev,
  autoconf-archive,
  libssl-dev,
@@ -17,8 +17,7 @@
 Vcs-Browser: https://salsa.debian.org/cryptocoin-team/libsecp256k1
 Rules-Requires-Root: no
 
-Package: libsecp256k1-1
-Section: libs
+Package: libsecp256k1-2
 Architecture: any
 Depends:
  ${misc:Depends},
@@ -53,8 +52,8 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libsecp256k1-1 (= ${binary:Version}),
- pkg-config,
+Depends: libsecp256k1-2 (= ${binary:Version}),
+ pkgconf,
  ${devlibs:Depends},
  ${misc:Depends}
 Description: library for EC operations on curve secp256k1 - development headers

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,6 @@
 	dh_auto_configure -- \
 		--enable-module-recovery \
 		--enable-module-ecdh \
-		--enable-experimental \
 		--enable-module-extrakeys \
 		--enable-module-schnorrsig
